## mgba 0.4.0+dfsg1

=== debian/changelog ===
mgba (0.4.0+dfsg1-3) unstable; urgency=low

  * Removed debug packages from control (automatic -dbgsym packages).

 -- Sérgio Benjamim <sergio_br2@yahoo.com.br>  Sun, 10 Apr 2016 22:12:00 -0300

mgba (0.4.0+dfsg1-2) unstable; urgency=low

  * Simplify debug packages long description.
  * Add comments to Copyright and use standard Zlib license name.

 -- Sérgio Benjamim <sergio_br2@yahoo.com.br>  Thu, 07 Apr 2016 17:50:00 -0300

mgba (0.4.0+dfsg1-1) unstable; urgency=low

  * Initial release (Closes: #787470).

 -- Sérgio Benjamim <sergio_br2@yahoo.com.br>  Wed, 06 Apr 2016 00:02:00 -0300
