## mgba 0.4.1+dfsg1

=== debian/changelog ===
mgba (0.4.1+dfsg1-1) unstable; urgency=low

  * New upstream release.
  * Changed package maintainer to Debian Games Team.
  * Added a common package for shaders and DAT.
  * Fixed hardening-no-bindnow and hardening-no-pie.
  * Bump Standards-Version to 3.9.8.

 -- Sérgio Benjamim <sergio_br2@yahoo.com.br>  Sun, 17 Jul 2016 23:04:00 -0300
